package fr.univamu.sorting;

import java.lang.reflect.Array;
import java.util.List;

public interface Sortable<T extends Comparable<T>> {
    T get(int index);
    int size();
    void swap(int index1, int index2);
    int compare(int index1, int index2);

    static <T extends Comparable<T>> Sortable of(List<T> A) {
        return new SortableIntList(A);
    }

    static <T extends Comparable<T>> Sortable of(T[] A) {
        return new SortableIntArray(A);
    }
}
